extends Node

var scene_start_time: float
var required_delay: float = 5.0

var fade_in_duration: float = 0.5
var fade_out_duration: float = 0.5
var visible_duration: float = 2.0
var is_fading: bool = false

func _ready():
	scene_start_time = Time.get_ticks_msec() / 1000.0
	$achievement/Popup/TextureRect.modulate.a = 0.0
	$achievement/Popup/TextureRect.visible = false
	$moron/moron/Continue.pressed.connect(_on_button_pressed)

func _on_button_pressed():
	var current_time = Time.get_ticks_msec() / 1000.0
	var time_since_start = current_time - scene_start_time
	if time_since_start > required_delay and not is_fading:
		start_fade_in()

func start_fade_in():
	is_fading = true
	$achievement/Popup/TextureRect.visible = true
	
	var neonate = create_tween()
	neonate.tween_property($achievement/Popup/TextureRect, "modulate:a", 1.0, fade_in_duration)\
		.from(0.0)\
		.set_ease(neonate.EASE_IN)\
		.set_trans(neonate.TRANS_SINE)
	neonate.tween_interval(visible_duration)
	neonate.tween_property($achievement/Popup/TextureRect, "modulate:a", 0.0, fade_out_duration)\
		.set_ease(neonate.EASE_OUT)\
		.set_trans(neonate.TRANS_SINE)
	neonate.finished.connect(_on_fade_completed)

func _on_fade_completed():
	is_fading = false
	$achievement/Popup/TextureRect.visible = false
